#include <vcl.h>
#include "utilit.h"

AnsiString IntToHEXString(unsigned int num)
{
 AnsiString d1="0x00000000";
 const static char m[]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
 int i,tmp;
 for(i=0;i<8;i++)
 {
  tmp=(num>>(i<<2))&0xf;
  d1.c_str()[9-i]=m[tmp];
 }
 return d1;
}

unsigned int HEXStringToInt(AnsiString str)
{
 unsigned int tmp=0,i;
 if(str.Length()<3)return 0;
 for(i=2;i<str.Length();i++)
 {
  tmp<<=4;
  if(str.c_str()[i]<='9' && str.c_str()[i]>='0')tmp|=str.c_str()[i]-'0';
  else if(str.c_str()[i]<='F' && str.c_str()[i]>='A')tmp|=str.c_str()[i]-'A'+10;
  else if(str.c_str()[i]<='f' && str.c_str()[i]>='a')tmp|=str.c_str()[i]-'a'+10;
  else break;
 }
 return tmp;
}

unsigned int deserial_revers(unsigned char *p, int num)
{
 int i;
 unsigned int tmp=0;
 for(i=0;i<num;i++)
 {
  tmp<<=1;
  tmp|=p[num-i-1]&0x1;
 }
 return tmp;
}

unsigned int deserial_direct_inc2(unsigned char *p, int num)
{
 int i;
 unsigned int tmp=0;
 for(i=0;i<num;i+=2)
 {
  tmp<<=1;
  tmp|=p[i]&0x1;
 }
 return tmp;
}

unsigned int revers_uint(unsigned int data)
{
 return ((data&0xff)<<24)|((data&0xff00)<<8)|((data&0xff0000)>>8)|((data&0xff000000)>>24);
}
