//---------------------------------------------------------------------------

#ifndef LPTH
#define LPTH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "TVICLPTLib_OCX.h"
#include <OleCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

#define  MaxMappedAreas            16
#define  MaxPins                   17

#define LPTACCESS_ERR_NONE             0
#define LPTACCESS_ERR_BAD_PORT         1
#define LPTACCESS_ERR_ACQUIRE_REFUSED  2

#define LPT_NOT_PRESENT          0
#define LPT_SPP_MODE             1
#define LPT_PS2_MODE             2
#define LPT_EPP_MODE             3
#define LPT_FAST_CENTRONIX       4
#define LPT_ECP_MODE             5

#define COMPATIBILTY_TRANSFER_MODE 0
#define NIBBLE_TRANSFER_MODE       1
#define BYTE_TRANSFER_MODE         2
#define EPP_TRANSFER_MODE          3
#define ECP_TRANSFER_MODE          4

//---------------------------------------------------------------------------

class TForm2 : public TForm
{
__published:	// IDE-managed Components
        TTVicLPT *TVicLPT1;
        TLabel *Label1;
        TButton *Button1;
        TListBox *ListBox1;
        TLabel *Label2;
        TListBox *ListBox2;
        TButton *Button2;
        TEdit *Edit1;
        TEdit *Edit2;
        TLabel *Label3;
        TLabel *Label4;
        TButton *Button3;
        TButton *Button4;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm2(TComponent* Owner);
        int __fastcall JTAG_init();
        void __fastcall JTAG_Command(int x);
        void __fastcall JTAG_ExenData(unsigned char *p, int bits);
        int __fastcall TDI();
        void __fastcall TMS(int x);
        void __fastcall TCK(int x);
        void __fastcall TDO(int x);
        void __fastcall TCK_1_0();
        int LPT_modes[10];
        unsigned short JTAG_out_state;
        

};
//---------------------------------------------------------------------------
extern PACKAGE TForm2 *Form2;
//---------------------------------------------------------------------------
#endif
